<template>
  <div v-loading="loading">
    <div
      v-if="!isHasGroupTitle"
      class="top-game-title border-l-[10px] border-b-2 w-full p-[5px] my-[10px] text-white"
    >
      {{ groupTitle }}
    </div>
    <div
      v-infinite-scroll="() => gameLoading()"
      :class="`blog-game text-xs grid gap-${gap} mb-1 green-peru__render-game`"
    >
      <div
        v-for="(game, index) in gameReadyToRender"
        :key="index"
        class="peru-theme__render-game max-w-[185px]"
      >
        <template v-if="authenticated">
          <div
            v-if="!game.IsMaintain"
            class="cursor-pointer"
            @click="handlePlayGame(game, 850, 850, 'GameLobby')"
          >
            <div class="peru-theme__render-game-container aspect-square relative">
              <div class="img-container group overflow-hidden">
                <div class="blur-background-custom" :style="{ 'background': 'center/175% url(' + game.GameIconUrl + ')' }"></div>
                <span class="icon-status" :class="checkStatus(game)"></span>
                <IconFavorite
                  :gameData="game"
                  :checkIsFavourite="checkIsFavourite"
                  :redirectToLogin="redirectToLogin"
                  :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
                <img
                  v-lazy="isImageVersionExist(game.GameIconUrl)"
                  :alt="game.GameName"
                  class="object-contain object-center w-full h-full rounded-2xl relative"
                />
              </div>
            </div>
            <el-tooltip
              :content="game.GameName"
              effect="light"
              popper-class="game-name"
              raw-content
            >
              <div class="leading-[35px] text-[var(--text2)] text-center truncate">{{ game.GameName }}</div>
            </el-tooltip>
          </div>
          <div v-else>
            <div class="peru-theme__render-game-container aspect-square relative">
              <div class="img-container group overflow-hidden">
                <div class="blur-background-custom" :style="{ 'background': 'center/175% url(' + game.GameIconUrl + ')' }"></div>
                <span class="icon-status" :class="checkStatus(game)"></span>
                <IconFavorite
                  :gameData="game"
                  :checkIsFavourite="checkIsFavourite"
                  :redirectToLogin="redirectToLogin"
                  :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
                <img
                  v-lazy="isImageVersionExist(game.GameIconUrl)"
                  :alt="game.GameName"
                  class="object-contain object-center w-full h-full rounded-2xl relative"
                />
              </div>
              <!-- <span class="icon-status" :class="checkStatus(game)"></span> -->
            </div>
            <el-tooltip
              :content="game.GameName"
              effect="light"
              popper-class="game-name"
              raw-content
            >
              <div class="leading-[35px] text-[var(--text2)] text-center truncate">{{ game.GameName }}</div>
            </el-tooltip>
          </div>
        </template>
        <div v-else @click="() => redirectToLogin()" class="cursor-pointer">
          <div class="peru-theme__render-game-container aspect-square relative">
            <div class="img-container group overflow-hidden">
              <div class="blur-background-custom group overflow-hidden" :style="{ 'background': 'center/175% url(' + game.GameIconUrl + ')' }"></div>
                <span class="icon-status" :class="checkStatus(game)"></span>
                <IconFavorite
                  :gameData="game"
                  :checkIsFavourite="checkIsFavourite"
                  :redirectToLogin="redirectToLogin"
                  :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
                <img
                  v-lazy="isImageVersionExist(game.GameIconUrl)"
                  :alt="game.GameName"
                  class="object-contain object-center w-full h-full rounded-2xl relative"
                />
              </div>

          </div>
          <el-tooltip
            :content="game.GameName"
            effect="light"
            popper-class="game-name"
            raw-content
          >
            <div class="leading-[35px] text-[var(--text2)] text-center truncate">{{ game.GameName }}</div>
          </el-tooltip>
        </div>
      </div>
      <ElBacktop :right="30" :bottom="30">
        <div class="w-[35px] h-[35px] flex items-center justify-center">
          <font-awesome-icon icon="arrow-up" class="text-black" />
        </div>
      </ElBacktop>
    </div>
    <div
      v-show="games.length === 0 && !loading"
      class="col-span-3 my-[60px] p-2 overflow-hidden text-4xl text-center truncate no-data text-ellipsis"
    >
    <span v-if="activeTab !== 'favorite'">{{ $t("no_games_please_come_back_later") }}</span>
    <span v-else>{{ $t('No game has been added to favorite.') }}</span>
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, PropType, ref, watch } from "vue";
import { ElBacktop } from "element-plus";
import { IGameBsi } from "@/models/bsiGameList";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import { store } from "@/store";
import IconFavorite from '@/components/icon/Favorite.client.vue';
export default defineComponent({
  name: "GameEntry",
  components: {
    ElBacktop,
    IconFavorite,
  },
  props: {
    loading: {
      type: Boolean,
      default: false,
    },
    games: {
      type: Array as PropType<IGameBsi[]>,
      default: () => [],
    },
    isHasGroupTitle: {
      type: Boolean,
      default: false,
    },
    groupTitle: {
      type: String,
      default: "",
    },
    classGameName: {
      type: String,
      default: "",
    },
    handlePlayGame: {
      type: Function,
      required: true,
      default: handleGameEntryOpenWindow,
    },
    grid: {
      type: Number,
      default: 6,
    },
    gap: {
      type: Number,
      default: 2,
    },
    showStaus: {
      type: Boolean,
      default: false,
    },
    activeTab: {
      type: String,
      default: '',
    },
  },
  setup(props) {
    const authenticated = computed(() => store.state.auth);
    const checkStatus = (game: IGameBsi): string => {
      let status = "disabled";
      if (props.showStaus) {
        if (game.IsNewGame && !game.IsHotGame) status = "new";
        if (game.IsHotGame) status = "hot";
      }
      return status;
    };
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const gameRender = computed(() => {
      const chunkSize = 24;
      const games = [];
      if (props.games !== undefined) {
        for (let i = 0; i < props.games.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined = props.games.slice(
            i,
            i + chunkSize
          );
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    if (props.games.length) {
      gameRenderer();
    }
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    const gameLoading = () => {
      index.value += 1;
      if (index.value < gameRender.value.length) {
        gameRenderer();
      }
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    const {
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    } = useAddToFavorite();
    return {
      authenticated,
      checkStatus,
      gameLoading,
      gameReadyToRender,
      isImageVersionExist,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    };
  },
});
</script>
<style scoped lang="scss">
@media (min-width: 1536px) {
  :deep(.green-peru__render-game) {
    grid-template-columns: repeat(6, minmax(0, 1fr));
    grid-gap: 24px;
    // img {
    //   height: 180px;
    //   width: 244.61px;
    // }
  }
}
@media (min-width: 1280px) and (max-width: 1534px) {
  :deep(.green-peru__render-game) {
    grid-template-columns: repeat(6, minmax(0, 1fr));
    grid-gap: 24px;
  }
}
@media (min-width: 1024px) and (max-width: 1279px) {
  :deep(.green-peru__render-game) {
    grid-template-columns: repeat(5, minmax(0, 1fr));
    grid-gap: 24px;
  }
}
@media (min-width: 768px) and (max-width: 1023px) {
  :deep(.green-peru__render-game) {
    grid-template-columns: repeat(4, minmax(0, 1fr));
    grid-gap: 16px;
  }
}
@media (min-width: 640px) and (max-width: 767px) {
  :deep(.green-peru__render-game) {
    grid-template-columns: repeat(3, minmax(0, 1fr));
    grid-gap: 16px;
  }
}
@media (min-width: 360px) and (max-width: 639px) {
  :deep(.green-peru__render-game) {
    grid-template-columns: repeat(3, minmax(0, 1fr));
    grid-gap: 16px;
  }
}
.blog-game {
  .icon-status:not(.disabled) {
    position: absolute;
    width: 60px;
    height: 28px;
    border-top-left-radius: 16px;
    border-bottom-right-radius: 16px;
    top: 0px;
    left: 0px;
    color: var(--text5);
    text-align: center;
    font-family: "Roboto";
    font-style: normal;
    font-weight: 700;
    font-size: 16px;
    letter-spacing: 0.02em;
    &.new {
      background-color: var(--primary);
      &::after {
        content: "New";
        position: absolute;
        top: 6px;
        left: 15px;
      }
    }
    [theme-color="bk8"] &.new {
      background-color: var(--primary);
      &::after {
        content: "NEW";
        position: absolute;
        top: 6px;
        left: 15px;
        color: white;
      }
    }
    &.hot {
      background-color: var(--secondary);
      &::after {
        content: "Hot";
        position: absolute;
        top: 6px;
        left: 15px;
      }
    }
    [theme-color="bk8"] &.hot {
      background-color: var(--secondary);
      &::after {
        content: "HOT";
        position: absolute;
        color: white;
        top: 6px;
        left: 15px;
      }
    }
  }
}
.blur-background-custom{
  -webkit-filter: blur(3px);
  width: 100%;
  height: 100%;
  position: absolute;
  left: 0;
}
</style>
<style>
.el-popper.is-light.game-name span {
  color: #5f5f5f;
}
.el-popper.is-light.game-name .el-popper__arrow::before {
  background: #fff;
}
</style>
